--[[ Announce ]]

if not FixR then return end

local DefaultO = {
  ["shout"] = false;
}
local misc = {
  ["desc"] = "Announce personal Cooldown uses";
  ["alpha"] = true;
  ["GUI"] = {
    [1] = {
      ["type"] = "Boolean";
      ["opt"] = "shout";
      ["desc"] = "tell CD usage to the party/raid";
    };
  };
}

local M = FixR:NewModule("Announce", DefaultO, misc)

--[[
RAID_CLASS_COLORS = {
  ["HUNTER"] = { r = 0.67, g = 0.83, b = 0.45, colorStr = "ffabd473" }, --171, 212, 115
  ["WARLOCK"] = { r = 0.58, g = 0.51, b = 0.79, colorStr = "ff9482c9" }, --148, 130, 201
  ["PRIEST"] = { r = 1.0, g = 1.0, b = 1.0, colorStr = "ffffffff" }, --255, 255, 255
  ["PALADIN"] = { r = 0.96, g = 0.55, b = 0.73, colorStr = "fff58cba" }, --245, 140, 186
  ["MAGE"] = { r = 0.41, g = 0.8, b = 0.94, colorStr = "ff69ccf0" }, --105, 204, 240
  ["ROGUE"] = { r = 1.0, g = 0.96, b = 0.41, colorStr = "fffff569" }, --255, 245, 105
  ["DRUID"] = { r = 1.0, g = 0.49, b = 0.04, colorStr = "ffff7d0a" }, --255, 125, 10
  ["SHAMAN"] = { r = 0.0, g = 0.44, b = 0.87, colorStr = "ff0070de" }, --0, 112, 222
  ["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43, colorStr = "ffc79c6e" }, --199, 156, 110
  ["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23, colorStr = "ffc41f3b" }, --196, 31, 59
  ["MONK"] = { r = 0.0, g = 1.00 , b = 0.59, colorStr = "ff00ff96" }, --0, 255, 150
};
--]]
local spellIDs = {
  --[[
  [774] = { --Rejuvenation
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  [1126] = { --Mark of the Wild
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  [5487] = { --Bear Form
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  --]]
  --Trinket: Rook's Unlucky Talisman
  [146343] = { --Avoidance (-42% aoe, 15s)
    ["displayColor"] = RAID_CLASS_COLORS["PRIEST"];
  };
  
  --Legendary meta gem
  [137593] = { --Fortutide (-20%, 15s)
    ["displayColor"] = RAID_CLASS_COLORS["PRIEST"];
  };
  
  --Death Knight
  [50461] = { --Anti-Magic Zone (-75% spell, max 10s)
    ["displayColor"] = RAID_CLASS_COLORS["DEATHKNIGHT"];
  };
  [122285] = { --Bone Shield (-10%, 3 charges, Symbiosis)
    ["displayColor"] = RAID_CLASS_COLORS["DEATHKNIGHT"];
  };
  --Druid
  [102342] = { --Ironbark (-20%, 12s)
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  --Feral Druid
  [139120] = { --Re-Origination (mastery += 2*(haste + crit); haste = crit = 0; 10s)
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  --Guardian Druid
  [22812] = {
    ["descON"] = "  ->Barkskin (-20%) 12s";
    ["descOFF"] = "Barkskin faded";
    ["shout"] = true;
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  [61336] = {
    ["descON"] = "  ->Survival Instincts (-50%) 12s";
    ["descOFF"] = "Survival Instincts faded";
    ["shout"] = true;
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  [106922] = {
    ["descON"] = "  ->Might of Ursoc (+30% HP) 20s";
    ["descOFF"] = "Might of Ursoc faded";
    ["shout"] = true;
    ["displayColor"] = RAID_CLASS_COLORS["DRUID"];
  };
  --Monk
  [120954] = {
    ["descON"] = "  ->Fortifying Brew (+20% HP, -20%) 20s";
    ["descOFF"] = "Fortifying Brew faded";
    ["shout"] = true;
    ["displayColor"] = RAID_CLASS_COLORS["MONK"];
  };
  --Paladin
  [1022] = { --Hand of Protection (-100% phys, 10s)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  };
  [6940] = { --Hand of Sacrifice (-30%, 12s, max 100%hp)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  };
  [31821] = { --Devotion Aura (-20% spell, 6s, silence/interrupt immune)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  };
  [114039] = { --Hand of Purity (-10%, 6s, -70% dot)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  };
  --Protection Paladin
  [498] = { --Devine Protection (-40% spell, 10s)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  };
  [86659] = { --Guardian of the Ancient Kings (-50%, 12s)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  }; --does not work!?
  [86657] = { --Guardian of the Ancient Kings/Ancient Guardian (-50%, 12s)
    ["displayColor"] = RAID_CLASS_COLORS["PALADIN"];
  }; --this also does not work (protection)
  --Priest
  [33206] = { --Pain Suppression (-40%, 8s)
    ["displayColor"] = RAID_CLASS_COLORS["PRIEST"];
  };
  [47788] = { --Guardian Spirit (+60% inc heal, 10s, 50%hp on death)
    ["displayColor"] = RAID_CLASS_COLORS["PRIEST"];
  };
  [81782] = { --Power Word: Barrier (-25%, 10s)
    ["displayColor"] = RAID_CLASS_COLORS["PRIEST"];
  };
  --Rogue
  [76577] = { --Smoke Bomb (-20%, 5s, 8yd)
    ["displayColor"] = RAID_CLASS_COLORS["ROGUE"];
  };
  --Warrior
  [97463] = { --Rallying Cry (+20% hp, 10s)
    ["displayColor"] = RAID_CLASS_COLORS["WARRIOR"];
  };
  [114030] = { --Vigilance (-30%, 12s)
    ["displayColor"] = RAID_CLASS_COLORS["WARRIOR"];
  };
  --Protection Warrior
  [871] = { --Shield Wall (-40%, 12s)
    ["displayColor"] = RAID_CLASS_COLORS["WARRIOR"];
  };
  [12975] = { --Last Stand (+30% HP, 20s)
    ["displayColor"] = RAID_CLASS_COLORS["WARRIOR"];
  };
}

local displayIDsOwn = {
  ["DRUID"] = {137593, 22812, 61336, 106922, 146343, 122285, 139120};
  ["PALADIN"] = {498, 86659,86657};
  ["MONK"] = {120954};
  ["WARRIOR"] = {871, 12975};
}
local displayIDsExternal = {
  --774, 1126, 5487,
  --Others
  102342, 76577, 81782, 50461, 114039, 33206, 6940, 31821, 1022, 47788, 97463, 114030
}

local frame = nil
local frameEvents = {};
local myGUID = nil
local function initFrame()
  local lastSpell, spellIndex
  --frame = CreateFrame("Frame")
  frame = CreateFrame("Frame", "FixR_Announce", UIParent)
  --frame:SetPoint(M.O["framePoint"], M.O["frameRelativeTo"], M.O["frameRelativePoint"], M.O["frameOffsetX"], M.O["frameOffsetY"])
  frame:SetPoint("RIGHT", UIParent, "CENTER", -200, 0)
  frame:SetFrameStrata("LOW")
  frame:SetSize(200, 40)
  --frame:SetAlpha(0.5)
  
  frame:SetScript("OnEvent", function(self, event, ...)
    frameEvents[event](self, ...); -- call one of the event functions
  end);
  
  frame.timeSinceLastUpdate = 0
  frame.timerInterval = 1
  
  frame.OnUpdate = function(self, elapsed)
    --[[
    self.timeSinceLastUpdate = self.timeSinceLastUpdate + elapsed
    if (self.timeSinceLastUpdate >= self.timerInterval) then --in seconds
      self:updatePosition()
      
      self.timeSinceLastUpdate = 0
    end
    --]]
    
    for k, v in pairs(self.spells) do
      if (v.tslU >= 0) then
        v.tslU = v.tslU + elapsed
        while (v.tslU >= 1) do
          v.durLeft = max(v.durLeft - 1, 0)
          if (v.durLeft <= 0) then
            v.tslU = -1
          else
            v.tslU = v.tslU - 1
          end
        end
        if v.durLeft <= 30 then
          v:SetText(v.spellName.." "..v.durLeft)
        else
          v:SetText(v.spellName)
        end
      end
    end
  end
  
  frame.spells = {}
  lastSpell = nil
  spellIndex = 0
  local _, englishClass = UnitClass("player")
  if displayIDsOwn[englishClass] then
    for i, v in ipairs(displayIDsOwn[englishClass]) do
      if spellIDs[v] then
        spellIDs[v]["display"] = true
        frame.spells[v] = frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
        
        --[[
        if lastSpell then
          frame.spells[v]:SetPoint("TOPRIGHT", lastSpell, "BOTTOMRIGHT")
        else
          frame.spells[v]:SetPoint("RIGHT")
        end
        --]]
        --lastSpell = frame.spells[v]
        frame.spells[v]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -11 * spellIndex)
        spellIndex = spellIndex + 1
        
        frame.spells[v]:SetText("")
        if spellIDs[v]["displayColor"] then
          frame.spells[v]:SetTextColor(spellIDs[v]["displayColor"].r, spellIDs[v]["displayColor"].g, spellIDs[v]["displayColor"].b, 1)
        else
          frame.spells[v]:SetTextColor(1, 1, 1, 1)
        end
      end
    end
  end
  lastSpell = nil
  for i, v in ipairs(displayIDsExternal) do
    if spellIDs[v] then
      spellIDs[v]["display"] = true
      spellIDs[v]["externalID"] = true
      frame.spells[v] = frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
      
      if lastSpell then
        frame.spells[v]:SetPoint("TOPRIGHT", lastSpell, "BOTTOMRIGHT")
      else
        frame.spells[v]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -11 * spellIndex)
      end
      lastSpell = frame.spells[v]
      
      frame.spells[v]:SetText("")
      frame.spells[v]:SetHeight(1)
      if spellIDs[v]["displayColor"] then
        frame.spells[v]:SetTextColor(spellIDs[v]["displayColor"].r, spellIDs[v]["displayColor"].g, spellIDs[v]["displayColor"].b, 1)
      else
        frame.spells[v]:SetTextColor(1, 1, 1, 1)
      end
    end
  end
  
  for k, v in pairs(frame.spells) do
    v.tslU = -1
    v.durLeft = 0
    v.spellName = ""
  end
  
  frame:SetScript("OnUpdate", function(self, elapsed)
    self.OnUpdate(self, elapsed)
  end);
end

--/dump GetNumGroupMembers("LE_PARTY_CATEGORY_INSTANCE")
--/dump GetNumGroupMembers("LE_PARTY_CATEGORY_HOME")

local function shout(text)
  if M.O["shout"] then
    local targetChannel = nil
    if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
      targetChannel = "INSTANCE_CHAT"
    elseif IsInRaid() then
      targetChannel = "RAID"
    elseif IsInGroup() then
      targetChannel = "PARTY"
    --elseif IsInGuild() then
    --  targetChannel = "GUILD"
    end
    if targetChannel then
      SendChatMessage(text, targetChannel)
    else
      FixR:Echo(text)
    end
  end
end

function frameEvents:COMBAT_LOG_EVENT_UNFILTERED(...)
  local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
  if event == "SPELL_AURA_APPLIED" then
    --if sourceGUID == myGUID then
    if destGUID == myGUID then
      local spellId, spellName, spellSchool = select(12, ...) --from prefix SPELL
      local auraType = select(15, ...) --BUFF or DEBUFF
      if auraType == "BUFF" then
        local v = spellIDs[spellId]
        if v then
          if v["shout"] then
            shout(v["descON"])
          end
          if v["display"] then
            if v["externalID"] then
              self.spells[spellId]:SetHeight(11)
            end
            
            local durationLeft = 0
            local i,name,_,_,_,_,dur,expTime,unitCaster,_,_,spellId2=1,UnitBuff("player",1)
            while name do
              if spellId == spellId2 then
                durationLeft = max(floor(expTime-GetTime()), durationLeft)
              end
              i=i+1
              name,_,_,_,_,dur,expTime,unitCaster,_,_,spellId2=UnitBuff("player",i)
            end
            
            self.spells[spellId].spellName = spellName
            self.spells[spellId].durLeft = durationLeft
            self.spells[spellId].tslU = 0
            
            self.spells[spellId]:SetText(spellName.." "..durationLeft)
          end
        --else
        --  shout("  ->"..spellName.." (id="..spellId..")")
        end
      end
    end
  elseif event == "SPELL_AURA_REFRESH" then
    if destGUID == myGUID then
      local spellId, spellName, spellSchool = select(12, ...) --from prefix SPELL
      local auraType = select(15, ...) --BUFF or DEBUFF
      if auraType == "BUFF" then
        local v = spellIDs[spellId]
        if v then
          if v["display"] then
            local durationLeft = 0
            local i,name,_,_,_,_,dur,expTime,unitCaster,_,_,spellId2=1,UnitBuff("player",1)
            while name do
              if spellId == spellId2 then
                durationLeft = max(floor(expTime-GetTime()), durationLeft)
              end
              i=i+1
              name,_,_,_,_,dur,expTime,unitCaster,_,_,spellId2=UnitBuff("player",i)
            end
            
            self.spells[spellId].spellName = spellName
            self.spells[spellId].durLeft = durationLeft
            self.spells[spellId].tslU = 0
            
            self.spells[spellId]:SetText(spellName.." "..durationLeft)
          end
        end
      end
    end
  elseif event == "SPELL_AURA_REMOVED" then
    --if sourceGUID == myGUID then
    if destGUID == myGUID then
      local spellId, spellName, spellSchool = select(12, ...)
      local auraType = select(15, ...)
      if auraType == "BUFF" then
        local v = spellIDs[spellId]
        if v then
          --is BUFF still applied? (stacks)
          local name, _, _, _, _, _, _, _, _, _, spellId2 = UnitBuff("player", spellName)
          if not (name and (spellId2 == spellId)) then
            if v["shout"] then
              shout(v["descOFF"])
            end
            if v["display"] then
              self.spells[spellId].tslU = -1
              self.spells[spellId]:SetText("")
              if v["externalID"] then
                self.spells[spellId]:SetHeight(1)
              end
            end
          end
        --else
        --  shout("  ->"..spellName.." (id="..spellId..") faded")
        end
      end
    end
  end
end

function M:Load()
  if not frame then
    initFrame()
  end
  local k, v
  for k, v in pairs(frameEvents) do
    frame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  myGUID = UnitGUID("player")
end

function M:Unload()
  if frame then
    local k, v
    for k, v in pairs(frameEvents) do
      frame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
  end
end

function M:SetOption(arg1, arg2)
  if arg1 == "shout" then
    local bln, updateGUI = nil, true
    if arg2 == 1 then
      bln = true
      updateGUI = false
    elseif arg2 == 0 then
      bln = false
      updateGUI = false
    else --toggle
      bln = not (M.O["shout"] or false)
    end
    M.O["shout"] = bln
    FixR:Echo("Announce: shout: "..(bln and "|cffaaffaaOn" or "|cffff8888Off"))
    if updateGUI then
      FixR:SetModuleGUIOption(M, 1, bln)
    end
  end
end

function M:ShowOptions()
end
