--[[ MinimapSquare
     Work in progress
  ]]

if not FixR then return end

local DefaultO = {
  ["MMButtonsHidden"] = false;
  ["WatchFrameHidden"] = false;
}
local misc = {
  ["desc"] = "Work in progress";
}

local M = FixR:NewModule("MinimapSquare", DefaultO, misc)

FixR_MinimapSquare_Button = CreateFrame("Frame", "FixR_MinimapSquare_Button", UIParent)
local frame, framePanel
local frameEvents = {};
local _G = _G
local min = min
local max = max
local sin = math.sin

function frameEvents:UPDATE_PENDING_MAIL(...)
  self:updateMailIcon()
end
function frameEvents:MAIL_CLOSED(...)
  --START of some code from Postal
  for i = 1, GetInboxNumItems() do
    if not select(9, GetInboxHeaderInfo(i)) then
      self:updateMailIcon()
      return
    end
  end
  --END of some code from Postal
  self:updateMailIcon(true)
end
--CALENDAR_UPDATE_INVITE_LIST
--CALENDAR_UPDATE_EVENT
function frameEvents:CALENDAR_UPDATE_EVENT_LIST()
  self:updateCalenderIcon()
end
function frameEvents:CALENDAR_UPDATE_PENDING_INVITES()
  self:updateCalenderIcon()
end

local function initFrame()
  local frameSize = 30
  
  frame = FixR_MinimapSquare_Button
  --frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 200, 100)
  frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 162, 54)
  frame:SetFrameStrata("LOW")
  frame:SetSize(frameSize, frameSize)
  frame:Show()
  --fixrMinimapSquare0x01 = frame
  
  frame.bgtexture = frame:CreateTexture(nil, "BORDER")
  frame.bgtexture:SetTexture("Interface\\Addons\\FixR\\graphics\\fixrround")
  frame.bgtexture:SetSize(frameSize-4, frameSize-4)
  frame.bgtexture:SetPoint("TOPLEFT", 2, -2)
  
  frame.buttonTexture = frame:CreateTexture(nil, "ARTWORK")
  frame.buttonTexture:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
  frame.buttonTexture:SetSize(52, 52)
  frame.buttonTexture:SetPoint("TOPLEFT")
  frame.buttonTexture:Show()
  
  frame:EnableMouse(true)
  frame.timeSinceLastUpdate = 0
  frame.timerInterval = 5
  frame.flash_NewEventIcon = false
  frame.flash_NewEventIcon_Timer = 0
  frame.flash_NewEventIcon_TimerMax = 2
  frame.flash_NewEventIcon_IndexMax = 2*PI
  
  frame.BlizMinimapFrame = nil
  frame.BlizMinimapBackdropFrame = _G["MinimapBackdrop"]
  --children of MinimapBackdrop:
  frame.BlizMinimapBackdropFrame_HideChildren = {
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapWorldMapButton",
  };
  for i, v in pairs(frame.BlizMinimapBackdropFrame_HideChildren) do
    local f = _G[v]
    if f then
      f:Hide()
    end
  end
  
  frame.BlizWatchFrame = _G["WatchFrame"]
  
  frame:SetScript("OnEvent", function(self, event, ...)
    frameEvents[event](self, ...); -- call one of the event functions
  end);
  frame:SetScript("OnEnter", function(self, event, ...)
    if QueueStatusFrame and QueueStatusFrame:GetParent() == self and QueueStatusMinimapButton and QueueStatusMinimapButton:IsShown() then
      QueueStatusFrame:Show()
    end
  end);
  frame:SetScript("OnLeave", function(self, event, ...)
    if QueueStatusFrame and QueueStatusFrame:GetParent() == self then
      QueueStatusFrame:Hide()
    end
  end);
  frame:SetScript("OnUpdate", function(self, elapsed)
    self.OnUpdate(self, elapsed)
  end);
  frame.toggleButtonPanel = function(self, blnShow)
    if blnShow then
      framePanel:Show()
    else
      framePanel:Hide()
    end
    M.O["MMButtonsHidden"] = (blnShow == false) or false
  end
  frame.toggleBlizWatchFrame = function(self, blnShow)
    if blnShow then
      self.BlizWatchFrame:Show()
    else
      self.BlizWatchFrame:Hide()
    end
    M.O["WatchFrameHidden"] = (blnShow == false) or false
  end
  frame:SetScript("OnMouseDown", function(self, button)
    if button == "LeftButton" then
      if IsShiftKeyDown() then
        if framePanel:IsShown() then
          self:toggleButtonPanel(false)
        else
          self:toggleButtonPanel(true)
        end
      elseif IsAltKeyDown() then
        if self.BlizWatchFrame:IsShown() then
          self:toggleBlizWatchFrame(false)
        else
          self:toggleBlizWatchFrame(true)
        end
      end
    end
  end);
  frame.OnUpdate = function(self, elapsed)
    self.timeSinceLastUpdate = self.timeSinceLastUpdate + elapsed
    while (self.timeSinceLastUpdate > self.timerInterval) do --in seconds
      framePanel:setChildren(self.BlizMinimapFrame:GetChildren())
      framePanel:setChildren(self.BlizMinimapBackdropFrame:GetChildren())
      framePanel:updateChildrenPositions()
      
      self.timeSinceLastUpdate = self.timeSinceLastUpdate - self.timerInterval
    end
    
    if self.flash_NewEventIcon then
      self.flash_NewEventIcon_Timer = self.flash_NewEventIcon_Timer + elapsed
      if self.flash_NewEventIcon_Timer > self.flash_NewEventIcon_TimerMax then
        self.flash_NewEventIcon_Timer = self.flash_NewEventIcon_Timer - self.flash_NewEventIcon_TimerMax
      end
      self.newEventIcon:SetAlpha(max(0, 0.5 + 0.5*sin(self.flash_NewEventIcon_Timer / self.flash_NewEventIcon_TimerMax * self.flash_NewEventIcon_IndexMax)))
    end
    
    --queue:"OpenCalendar()"
    if self.timer_OpenCalendar >= 0 then
      self.timer_OpenCalendar = self.timer_OpenCalendar - elapsed
      if self.timer_OpenCalendar <= 0 then
        self.timer_OpenCalendar = -1
        OpenCalendar()
      end
    end
  end
  frame.updateMailIcon = function(self, forceHideIcon)
    if forceHideIcon then
      self.newMailIcon:Hide()
    else
      if self.newMailIcon then
        if HasNewMail() then
          self.newMailIcon:Show()
        else
          self.newMailIcon:Hide()
        end
      end
    end
  end
  frame.updateCalenderIcon = function(self)
    if self.newEventIcon then
      local invites = CalendarGetNumPendingInvites()
      --eventIndex = CalendarGetFirstPendingInvite([-1, 0, 1], monthDay)
      --numEvents = CalendarGetNumDayEvents([-1, 0, 1], monthDay)
      --title, hour, minute, calendarType, sequenceType, eventType, texture, modStatus, inviteStatus, invitedBy, difficulty, inviteType, sequenceIndex, numSequenceDayss = CalendarGetDayEvent(monthOffset, day, eventIndex)
      
--[[
local presentWeekday, presentMonth, presentDay, presentYear = CalendarGetDate();
local prevMonth, prevYear, prevNumDays = CalendarGetMonth(-1);
local nextMonth, nextYear, nextNumDays = CalendarGetMonth(1);
local month, year, numDays, firstWeekday = CalendarGetMonth();
--]]
      if invites > 0 then
        self.newEventIcon:Show()
        --local presentWeekday, presentMonth, presentDay, presentYear = CalendarGetDate()
        local _, _, presentDay, _ = CalendarGetDate()
        --local month, year, numDays, firstWeekday = CalendarGetMonth()
        local _, _, numDays, _ = CalendarGetMonth()
        --local nextMonth, nextYear, nextNumDays = CalendarGetMonth(1)
        local blnFlashIcon = false
        local checkDay, checkMonth, daysChecked = presentDay, 0, 0
        while (daysChecked < 6) and (blnFlashIcon == false) do
          local eventIndex = CalendarGetFirstPendingInvite(checkMonth, checkDay) --this might only return values greater than zero after "OpenCalendar()"
          if eventIndex > 0 then
            blnFlashIcon = true
          else
            checkDay = checkDay + 1
            if checkDay > numDays then
              checkDay = 1
              checkMonth = 1
            end
          end
          daysChecked = daysChecked + 1
        end
        if blnFlashIcon then
          self.flash_NewEventIcon = true
          self.flash_NewEventIcon_Timer = 0
        else
          self.flash_NewEventIcon = false
          self.newEventIcon:SetAlpha(1)
        end
      else
        self.newEventIcon:Hide()
        self.flash_NewEventIcon = false
      end
    end
  end
  
  framePanel = CreateFrame("Frame", "FixR_MinimapSquare_Panel", frame)
  framePanel:SetPoint("TOPLEFT", frame, "TOPRIGHT", 0, 0)
  framePanel:SetFrameStrata("LOW")
  framePanel:SetSize(40, 40)
  framePanel:Show()
  
  --[[
  framePanel.texture = framePanel:CreateTexture()
  framePanel.texture:SetAllPoints(framePanel)
  framePanel.texture:SetTexture(1, 0.67, 0.67, 1)
  --]]
  
  framePanel.listChildren = {}
  framePanel.listLength = 0
  
  --no border
  local fCluster = _G["MinimapCluster"]
  local fBackdrop = _G["MinimapBackdrop"];
  fBackdrop:Hide()
  fBackdrop:SetParent(fCluster)
  
  --square minimap
  frame.BlizMinimapFrame = _G["Minimap"]
  frame.BlizMinimapFrame:SetMaskTexture("Interface\\Buttons\\White8x8")
  frame.BlizMinimapFrame:SetParent(UIParent)
  frame.BlizMinimapFrame:ClearAllPoints()
  frame.BlizMinimapFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 10, 7) --10 right, 7 up
  frame.BlizMinimapFrame:SetSize(148,148)
  
  fCluster:Hide()
  
  
  framePanel.setChildren = function(self, ...)
    local maxChildren = select("#", ...)
    local numChildren = self.listLength
    for i = 1, maxChildren do
      local nextChild = select(i, ...)
      if true then --if nextChild:IsShown() then --add them anyway, could be temporarily hidden
        nextChild:SetParent(self)
        nextChild:ClearAllPoints()
        --nextChild:SetPoint("TOPLEFT", self, "TOPLEFT", (numChildren * 32), 0)
        --width=31, GameTimeFrame:40
        nextChild:SetSize(31,31)
        numChildren = numChildren + 1
        
        self.listChildren[numChildren] = nextChild
      end
    end
    self.listLength = numChildren
  end
  
  framePanel.updateChildrenPositions = function(self)
    local num = 0
    for i, v in ipairs(self.listChildren) do
      if v.IsShown and v:IsShown() then
        --self.listChildren[k] = 1
        v:SetPoint("TOPLEFT", self, "TOPLEFT", (num * 32), 0)
        num = num + 1
      else
        --self.listChildren[k] = 0
      end
    end
  end
  
  local tex = frame:CreateTexture(nil, "OVERLAY")
  tex:SetTexture("Interface\\Icons\\INV_Letter_15")
  tex:SetSize(14, 14)
  tex:SetPoint("TOPRIGHT")
  tex:Hide()
  frame.newMailIcon = tex
  
  local tex2 = frame:CreateTexture(nil, "OVERLAY")
  tex2:SetTexture("Interface\\Calendar\\EventNotification")
  tex2:SetSize(14, 16)
  tex2:SetPoint("BOTTOMRIGHT", 5, -3)
  tex2:Hide()
  frame.newEventIcon = tex2
  
  
  --delay the first call of OpenCalendar() by 5 sec
  frame.timer_OpenCalendar = 5
  
  do
    --[[
    local f
    f=function(...)
      print(select("#", ...),"children")
      for i = 1, select("#", ...) do
        print(i,"...")
        local n = select(i, ...)
        n.fgXY = n:CreateTexture(nil, "OVERLAY")
        n.fgXY:SetAllPoints(n)
        n.fgXY:SetTexture(1, 0.68, 0.79, 0.4)
        n.fgXY:Show()
        --FixR_MinimapSquare_F(n:GetChildren())
        f(n:GetChildren())
      end
    end
    --]]
    --/run local f;f=function(a)a.z9_=a:CreateTexture(nil,"OVERLAY");a.z9_:SetAllPoints(a);a.z9_:SetTexture(random(255)/255,random(255)/255,random(255)/255,0.3);a.z9_:Show();for i=1,select("#",a:GetChildren())do f(select(i,a:GetChildren()))end;end;f(UIParent)
    --/run local r,f=random;f=function(a)a.z9_=a.z9_ or a:CreateTexture(nil,"OVERLAY");a.z9_:SetAllPoints();a.z9_:SetTexture(r(255)/255,r(255)/255,r(255)/255,0.3);a.z9_:Show();for i=1,select("#",a:GetChildren())do f(select(i,a:GetChildren()))end;end;f(UIParent)
    --FixR_MinimapSquare_F = f
    --/run FixR_MinimapSquare_F(UIParent:GetChildren())
  end
end

function M:Load()
  if frame == nil then  
    initFrame()
  end
  for k, v in pairs(frameEvents) do
    frame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  frame:Show()
  if M.O["MMButtonsHidden"] then
    frame:toggleButtonPanel(false)
  end
  if M.O["WatchFrameHidden"] then
    frame:toggleBlizWatchFrame(false)
  end
  frame:updateMailIcon()
  frame:updateCalenderIcon()
  SetCVar("cameraDistanceMaxFactor", 3.4) --default = 2
end
function M:Unload()
  if frame then
    for k, v in pairs(frameEvents) do
      frame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
    frame:Hide()
    --TexFrame:Hide()
  end
end

function M:SetOption(arg1, arg2)
end